unit Curs;
{Function to use animate icon for mouse cursor}

interface

uses WinTypes, WinProcs, SysUtils, Classes, call32nt;


var
  W32LoadCursorFromFile:function(AniFileName:pchar;id:longint):longint;

var
  id_W32LoadCursorFromFile:longint;

Type TTypeCurs  = (ctANI,ctCUR);

  function LoadAniCursor(Instance: THandle; TypC:TTypeCurs; ResID: PChar): HCursor;

implementation

  function LoadAniCursor(Instance: THandle; TypC:TTypeCurs; ResID: PChar): HCursor;
  {part of RX library}
  var
    S: TFileStream;
    FileName:String;
    Rsrc: THandle{HRSRC};
    Res: THandle;
    Data: Pointer;
  begin
    Result := 0;
    Rsrc := FindResource(Instance, ResID, RT_RCDATA);
    if Rsrc <> 0 then begin
      If TypC=ctANI Then
        FileName:=ChangeFileExt(ParamStr(0), '.ANI')
      Else
        FileName:=ChangeFileExt(ParamStr(0), '.CUR');
      try
        Res := LoadResource(Instance, Rsrc);
        try
          Data := LockResource(Res);
          if Data <> nil then
          try
            S := TFileStream.Create(FileName, fmCreate);
            try
              S.WriteBuffer(Data^, SizeOfResource(Instance, Rsrc));
            finally
              S.Free;
            end;
            Filename := Filename+#0;
            Result := W32LoadCursorFromFile(@FileName[1],id_W32LoadCursorFromFile);
          finally
            UnlockResource(Res);
          end;
        finally
          FreeResource(Res);
        end;
      finally
        DeleteFile(FileName);
      end;
    end;
  end;



begin
  @W32LoadCursorFromFile:=@Call32;

  id_W32LoadCursorFromFile:=Declare32('LoadCursorFromFile', 'user32', 'p');
end.
